/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
// ユーザ登録処理　登録ビジネスAction
// 
//
//	変更履歴
//	2004.01.08 新規作成 M.Seko 
//

package jp.co.ntt.lms.xms.people;

import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import jp.co.ntt.lms.xmo.Environment;
import jp.co.ntt.lms.xmo.Mail.MailConst;
import jp.co.ntt.lms.xmo.People.PeopleClient;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsInnerException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsSystemException;
import jp.co.ntt.lms.xms.common.mail.InputFrameErrorBean;
import jp.co.ntt.lms.xms.common.mail.MailTemplateConstant;
import jp.co.ntt.lms.xms.common.mail.SendUser;
import jp.co.ntt.lms.xms.common.util.CommonUtil;

/**
 * ユーザ登録処理用クラス<br>
 * PeopleClientクラスを用いて、DBにユーザを登録する。
 */
public class PeopleInsertRegistBusinessAction extends XmsBusinessAction {

	/**
	 * @see jp.co.ntt.lms.xms.framework.XmsBusinessAction#initProcessRequest(XmsRequest)
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {
	}

	/**
	 * ユーザ登録処理<br>
	 * FORMで入力された値を用いてユーザを登録する。<br>
	 * なお、クライアント側で行われるデータのチェックと重複するチェックは、本メソッドでは行わない。
	 * @see jp.co.ntt.lms.xms.framework.XmsBusinessAction#processRequest(XmsRequest, XmsResponse)
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse)
		throws XmsException {

		// Request参照のために使用
		HttpServletRequest request = null;
		// Session参照のために使用
		HttpSession session = null;

		request = xmsRequest.getRequest();
		session = request.getSession(false);
		if(session == null){
			//sessionが無効である場合、処理が続行できないので例外を吐く
			throw new XmsSystemException("This session is invalid.");
		}

		//フォームデータ退避用に使用
		//エラー画面からの復帰にFormの情報が必要になるため
		PeopleFormInfoBean peopleFormInfoBean = new PeopleFormInfoBean();

		//フォームのデータをbeanに詰める。

		peopleFormInfoBean.setLoginIDString((String) request.getParameter("loginID"));
		peopleFormInfoBean.setForeignIDString((String) request.getParameter(("foreignID")));
		peopleFormInfoBean.setPasswordString((String) request.getParameter("password"));
		peopleFormInfoBean.setPasswordSureString((String) request.getParameter("passwordSure"));
		peopleFormInfoBean.setUsernameString((String) request.getParameter("username"));
		peopleFormInfoBean.setReading_nameString((String) request.getParameter(("reading_name")));
		peopleFormInfoBean.setEmailString((String) request.getParameter("email"));
		peopleFormInfoBean.setEmail2String((String) request.getParameter("email2"));
		peopleFormInfoBean.setUseraddressString((String) request.getParameter("useraddress"));
		peopleFormInfoBean.setContact_telString((String) request.getParameter("contact_tel"));
		peopleFormInfoBean.setBirthdayString((String) request.getParameter("birthday"));
		peopleFormInfoBean.setSexString((String) request.getParameter("sex"));
		peopleFormInfoBean.setTxtDescriptionString((String) request.getParameter("txtDescription"));
		peopleFormInfoBean.setIsSendPasswordString((String) request.getParameter("SendPassword"));
		peopleFormInfoBean.setParentID((String) request.getParameter("parentID"));


		//beanをセッションに登録する。
		session.setAttribute(PeopleConst.PeopleFormInfoSessionKey, peopleFormInfoBean);

		//XMsS.iniファイルからユーザPrefix情報を取得する
		String StrPrefix = null;
		try {
			Environment ObjEnv = new Environment();
			StrPrefix = ObjEnv.getPePrefix();
		} catch (Exception e) {
			throw new XmsSystemException(e);
		}

		//People管理XMOクライアントクラスを生成する
		PeopleClient objPeople = null;
		try {
			objPeople = new PeopleClient();
		} catch (Exception e) {
			throw new XmsSystemException(e);
		}

		//ユーザ登録に必要なパラメータを設定する。

		objPeople.setLoginID(peopleFormInfoBean.getLoginIDString()); // ログインID

		if (StrPrefix == null) {
			//XMS.iniファイルにユーザPrefixが設定されていない場合のみ外部IDを設定する
			objPeople.setForeignID(peopleFormInfoBean.getForeignIDString());
		}

		objPeople.setUserName(peopleFormInfoBean.getUsernameString()); // ユーザ名
		objPeople.setEncryptPassword(peopleFormInfoBean.getPasswordString()); // パスワード名
		objPeople.setContactAddress(peopleFormInfoBean.getUseraddressString()); // 住所
		objPeople.setSex(peopleFormInfoBean.getSexString()); // 性別
		objPeople.setContactEmail(peopleFormInfoBean.getEmailString()); // メールアドレス名
		objPeople.setContactEmail2(peopleFormInfoBean.getEmail2String()); // メールアドレス
		objPeople.setReadingName(peopleFormInfoBean.getReading_nameString()); // カナ
		objPeople.setBirthday(peopleFormInfoBean.getBirthdayString()); // 誕生日
		objPeople.setContactTel(peopleFormInfoBean.getContact_telString()); // 電話番号
		objPeople.setCustomMsgDir(peopleFormInfoBean.getTxtDescriptionString()); // コメント
		objPeople.setDeleteFlag("0"); // 隠しフラグ(固定)
		objPeople.setParentID(peopleFormInfoBean.getParentID()); // 親グループID指定 
		objPeople.setUserType("1"); // ユーザ種別(XMS2種別に設定)

		// 登録メソッド実行
		try {
			if (objPeople.insert() == false) {
				// 登録がうまくいかなかった場合
				if (objPeople.isErr() == true) {
					// 普通にエラーの場合は、エラー画面に遷移する。

					InputFrameErrorBean inputFrameErrorBean = new InputFrameErrorBean();
					inputFrameErrorBean.setErrorMessage(objPeople.getMessage());
					inputFrameErrorBean.setActionId("PeopleInsert.reDisplay");
					inputFrameErrorBean.setButtonType(InputFrameErrorBean.BUTTON_TYPE_RETURN);

					//エラー情報をセッションに登録する
					session.setAttribute(MailTemplateConstant.KEY_ERROR_INFO, inputFrameErrorBean);

					//エラー画面に遷移するステータスをセット
					xmsResponse.setBusinessStatus("error");
				} else {

					// ログインID重複・外部ID重複などのエラーの場合は、ポップアップでエラーを表示する。
					// InputFrameErrorBeanを使用しているが、遷移先JSPは業務固有のものを使用する。

					InputFrameErrorBean inputFrameErrorBean = new InputFrameErrorBean();
					String messeageID = objPeople.getMessageID();
					String message = objPeople.getMessage();
					inputFrameErrorBean.setErrorMessage(message);
					inputFrameErrorBean.setButtonType(InputFrameErrorBean.BUTTON_TYPE_RETURN);
					//エラー画面から復帰後、フォームのフォーカスを、
					//問題のあったフィールドにあわせるためにメッセージIDを格納しておく。
					inputFrameErrorBean.addParameter("MessageID", messeageID);

					//エラー情報をセッションに追加する
					session.setAttribute(
						MailTemplateConstant.KEY_ERROR_INFO,
						inputFrameErrorBean);

					//ポップアップのエラー画面に遷移するステータスをセット
					xmsResponse.setBusinessStatus("warn");
				}
				
				//エラー状態であり処理の続行が不可能なので、メソッドを終了する。
				return;
			}
		} catch (Exception e) {
			throw new XmsInnerException(e);
		}


		//フォームのパスワード通知にチェックが付いていれば、メール送信を行う準備をする。
		//もし、フォームのパスワード通知にチェックが付いていなければ、ユーザ登録処理を正常終了する。
		String passwordString = peopleFormInfoBean.getIsSendPasswordString();
		if (passwordString.equals("1") == true) {
			//フォームのパスワード通知にチェックが付いている場合

			/** メール送信相手のユーザID*/
			String toMailUserID = "";

			//メール送信に必要な情報を準備する。

			//送信相手（今回登録したユーザ）のユーザIDを検索し取得する。
			objPeople.setWhereLoginID(peopleFormInfoBean.getLoginIDString());
			try {
				if (objPeople.select() == false) {
					//ユーザID取得失敗。

					InputFrameErrorBean inputFrameErrorBean = new InputFrameErrorBean();
					inputFrameErrorBean.setErrorMessage(objPeople.getMessage());
					inputFrameErrorBean.setButtonType(InputFrameErrorBean.BUTTON_TYPE_RETURN);
					inputFrameErrorBean.setActionId("PeopleInsert.reDisplay");
					//エラー情報をセッションに追加する
					session.setAttribute(MailTemplateConstant.KEY_ERROR_INFO, inputFrameErrorBean);

					//エラー画面へ遷移するための状態をセット
					xmsResponse.setBusinessStatus("error");
					return;
				}

				if (objPeople.next() == true) {
					//ユーザＩＤの取得に成功した場合
					toMailUserID = objPeople.getUserID();
				} else {
					//ユーザID取得に失敗した場合

					InputFrameErrorBean inputFrameErrorBean = new InputFrameErrorBean();
					inputFrameErrorBean.setErrorMessage(PeopleConst.M032010);
					inputFrameErrorBean.setButtonType(InputFrameErrorBean.BUTTON_TYPE_RETURN);
					inputFrameErrorBean.setActionId("PeopleInsert.reDisplay");

					//エラー情報をセッションに追加する
					session.setAttribute(MailTemplateConstant.KEY_ERROR_INFO, inputFrameErrorBean);

					//エラー画面へ遷移するための状態をセット
					xmsResponse.setBusinessStatus("error");
					return;
				}
			} catch (Exception e) {
				//objPeople.select()時に、吐かれる可能性のあるExceptionをキャッチする
				//環境が原因でExceptionが吐かれる可能性が高いので、SystemExceptionとする。
				throw new XmsSystemException(e);
			}

			//メール送信に必要な情報をセットする。
			//メール送信に必要な情報を格納する。
			SendUser sendUser = null;
			//ユーザIDのリストを格納する
			Vector userListVector = null;

			sendUser = new SendUser();

			sendUser.setMailType(Integer.valueOf(MailConst.TYPE_REGIST).intValue());
			sendUser.setSendCountMax(1);
			userListVector = new Vector();
			userListVector.add(toMailUserID);
			sendUser.setUserAndLo(userListVector);
			// メール送信後のDispath先Screen Status Name
			sendUser.setStatus("userinsert");

			// 登録ユーザ情報
			session.setAttribute(MailConst.SKEY_SENDUSER, sendUser);
			// メール種別
			session.setAttribute(MailConst.SKEY_MAILTYPE, MailConst.TYPE_REGIST);

			//メール送信のステータスをセット
			xmsResponse.setBusinessStatus("successWithMail");
		} else {
			//メール送信にチェックが付いていなければ、正常終了する

			//メール送信しないステータスをセット
			xmsResponse.setBusinessStatus("successWithoutMail");
		}

		//セッションに登録されているこの業務特有のセッションのデータを削除

		//セッションキー保持クラスのセッションからの取得試行用
		SKeyKeep skeyKeep = null;

		skeyKeep = (SKeyKeep) session.getAttribute(PeopleConst.SKeyKeepSessionKey);
		if (skeyKeep != null) {
			//セッションキー保持クラスがセッションに存在している。
			//よって、セッションキー保持クラスが保持しているセッションキーに結びついているデータを削除
			CommonUtil.removeSessionData(xmsRequest, skeyKeep.getSkeyStringArray());
		}

	}
	

}
